Files
asterisk/safe_asterisk
T

78 lines
1.7 KiB
Bash
Raw Normal View History

2002-05-27 23:15:47 +00:00
#!/bin/sh
TTY=9 # TTY (if you want one) for Asterisk to run on
CONSOLE=yes # Whether or not you want a console
2003-02-18 18:15:30 +00:00
#NOTIFY=ben@alkaloid.net # Who to notify about crashes
DUMPDROP=/tmp
2002-05-27 23:15:47 +00:00
#
# Don't fork when running "safely"
#
2002-07-30 14:17:55 +00:00
ASTARGS=""
2002-05-27 23:15:47 +00:00
if [ "$TTY" != "" ]; then
2003-02-18 18:15:30 +00:00
if [ -c /dev/tty${TTY} ]; then
TTY=tty${TTY}
elif [ -c /dev/vc/${TTY} ]; then
TTY=vc/${TTY}
else
echo "Cannot find your TTY (${TTY})" >&2
exit 1
fi
2003-05-07 22:33:55 +00:00
ASTARGS="${ASTARGS} -vvvg"
2002-05-27 23:15:47 +00:00
if [ "$CONSOLE" != "no" ]; then
ASTARGS="${ASTARGS} -c"
fi
fi
2003-02-18 18:15:30 +00:00
if [ ! -w ${DUMPDROP} ]; then
echo "Cannot write to ${DUMPDROP}" >&2
exit 1
fi
2002-05-27 23:15:47 +00:00
#
# Let Asterisk dump core
#
ulimit -c unlimited
2002-10-08 17:14:31 +00:00
#launch_asterisk()
#{
#}
2002-05-27 23:15:47 +00:00
2002-07-30 14:17:55 +00:00
run_asterisk()
{
while :; do
if [ "$TTY" != "" ]; then
2003-02-18 18:15:30 +00:00
cd /tmp
stty sane < /dev/${TTY}
asterisk ${ASTARGS} >& /dev/${TTY} < /dev/${TTY}
2002-07-30 14:17:55 +00:00
else
2003-02-18 18:15:30 +00:00
cd /tmp
2002-07-30 14:17:55 +00:00
asterisk ${ASTARGS}
2002-05-27 23:15:47 +00:00
fi
2002-07-30 14:17:55 +00:00
EXITSTATUS=$?
2003-02-18 18:15:30 +00:00
echo "Asterisk ended with exit status $EXITSTATUS"
2002-07-30 14:17:55 +00:00
if [ "$EXITSTATUS" = "0" ]; then
# Properly shutdown....
echo "Asterisk shutdown normally."
exit 0
elif [ $EXITSTATUS -gt 128 ]; then
let EXITSIGNAL=EXITSTATUS-128
echo "Asterisk exited on signal $EXITSIGNAL."
if [ "$NOTIFY" != "" ]; then
echo "Asterisk exited on signal $EXITSIGNAL. Might want to take a peek." | \
mail -s "Asterisk Died" $NOTIFY
fi
2003-02-18 18:15:30 +00:00
if [ -f /tmp/core ]; then
mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
fi
2002-07-30 14:17:55 +00:00
else
echo "Asterisk died with code $EXITSTATUS. Aborting."
2003-02-18 18:15:30 +00:00
if [ -f /tmp/core ]; then
mv /tmp/core ${DUMPDROP}/core.`hostname`-`date -Iseconds` &
fi
2002-07-30 14:17:55 +00:00
exit 0
fi
echo "Automatically restarting Asterisk."
done
}
run_asterisk &